/***************************************************************************
                               PackageSelect.h
                             -------------------                                         
    begin                : Fri Oct 29 1999                                           
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd. 
    author		           : Anton Safonov
    author email         : as@bestlinux.net
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.                      
                            http://bestlinux.net                            

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#ifndef PackageSelect_included
#define PackageSelect_included

#include "PackageSelectData.h"
#include "config.h"
#include <rpmlib.h>

#include "installselect.h"
class PackageListItem;

class PackageSelect : public PackageSelectData {
    Q_OBJECT

public:
    PackageSelect( QWidget *parent, InstallSelect *install, const char *name = NULL );
    virtual ~PackageSelect();

		void showEvent( QShowEvent * );

		void insertItems();
		void initializeSelection();

public slots: // Public slots
	  void slotSelectionChanged(class QListViewItem *);
	  void slotCurrentChanged(class QListViewItem *);
		void slotToggleSelectionOfPackage(class QListViewItem *);
		void slotTotalChanged( int a_size );
		void updateDependencies();
		void displayFreeSpace();

private:
		PackageListItem *findAppropriateGroup( QString& a_group );

		InstallSelect *install;

		PackageListItem *root;

		bool initialized;
};
#endif // PackageSelect_included
























