/***************************************************************************
                          lfdisk.h
                          -------------------
    begin                : Thu Nov 11 1999
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd.
    author		 : Anton Safonov (Maddy)
    author email         : as@bestlinux.net
    url			 : http://www.bestlinux.net
    email		 : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.
                            http://bestlinux.net

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef FDISK_H
#define FDISK_H

#include "config.h"
#include <qwidget.h>
#include <qlabel.h>
#include <qmovie.h>
#include <qlayout.h>
#include <qlist.h>
#include <qpixmap.h>
#include <qstring.h>
#include <qslider.h>
#include <qframe.h>
#include <qspinbox.h>
#include <qlineedit.h>
#include <qcombobox.h>
#include <qstack.h>
#include <qscrollview.h>
#include <qpushbutton.h>
#include <qlistview.h>
#include <qbuttongroup.h>
#include <qcheckbox.h>
#include <qdialog.h>
#include <qstringlist.h>
#include <qdict.h>

class Fdisk
{
public:

    static QString sysname(unsigned char type);
    static int systype( const QString& name);
    static bool isExtendedType( unsigned char type);
    static bool isSwapType( unsigned char type);
    static bool isVFatType( unsigned char type);
    static bool isInstallSource( QString name);

    static bool getDiskGeometry( const QString& disk, int& heads, int& sectors, int& cylinders);
    static QString getPartitionTable( const QString& disk);
    static bool writePartitionTable( const QString& disk, const QString& table);

    static QStringList availableDisks();
    static bool isNew( const QString& partition );
    static void markAsNew( const QString& partition );
    static bool willBeFormated( const QString& partition );
    static void setFormatting( const QString& partition, bool value );

		static bool startup;

private:
    static QDict<QString> *newPartitions;
    static QDict<void> *formatPartitions;
};


#endif


