/***************************************************************************
                               finalpage.cpp
                             -------------------                                         
    begin                : Fri Nov 5 1999                                           
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd. 
    author		           : Anton Safonov (Maddy)
    author email         : as@bestlinux.net                                          
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.                      
                            http://bestlinux.net                            

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#include "finalpage.h"

#include "llanguage.h"
#include <qlayout.h>
#include <qdir.h>
#include <qmime.h>
#include "config.h"

FinalPage::FinalPage( QWidget * parent, const QString &a_language, const char * name )
    : QWidget( parent, name ), strLanguage( a_language )
{
  QVBoxLayout * l  = new QVBoxLayout();
  QHBoxLayout * h = new QHBoxLayout( this );

  someText = new LInlineHelp( this );
	someText->setMinimumWidth( 10 );
	someText->setMaximumWidth( 800 );
	setDocument( "welcome.html" );

  l->addSpacing( 10 );
  l->addWidget( someText );
  l->addSpacing( 10 );

  h->addSpacing( 10 );
  h->addLayout( l );
  h->addSpacing( 10 );

}

FinalPage::~FinalPage() {
}

void FinalPage::setDocument( const QString &a_str )
{
#ifdef GBLI_DEVEL
	QString	strPath = "/data/projects/T-1/docs/manuals/";
#else
	QString	strPath = "/mnt/install/docs/manuals/";
#endif
  int numLanguages = sizeof(languages) / sizeof(struct langInfo);

	int i = 0;
  for( ; i < numLanguages; i++ )
		if( !strcasecmp( languages[i].lang, strLanguage.ascii() ) )
			break;
	QString strLang = "en";
	if( i < numLanguages ){
		strLang = QString::fromLatin1( languages[i].key );
    if( !QFile( strPath + strLang +"/"+ a_str ).exists() &&
				!QFile( strPath + strLang +"/index.html" ).exists() )
			strLang = "en";
	}
	QMimeSourceFactory *mimefuck = (QMimeSourceFactory *)someText->mimeSourceFactory();
  someText->mimeSourceFactory()->setFilePath( QStringList( strPath + strLang ) );
	if( strLang == "ru" ){
		mimefuck->setExtensionType( "html", "text/html;charset=koi8-r");
		mimefuck->setExtensionType( "htm", "text/html;charset=koi8-r");

//		someText->mimeSourceFactory()->setExtensionType( "html", "text/html;charset=koi8-r");
//		someText->mimeSourceFactory()->setExtensionType( "htm", "text/html;charset=koi8-r");
    QFont font( QFont::defaultFont() );
		font.setFamily( "helvetica" );
//		font.setPointSize( 28 );
		font.setCharSet( QFont::KOI8R );
		someText->viewport()->setFont( font );
		//koi8-r, KOI8R, KOI8-R, AnyCharSet  ??? which one is right
	}else{
		mimefuck->setExtensionType( "html", "text/html;charset=iso8859-1");
		mimefuck->setExtensionType( "htm", "text/html;charset=iso8859-1");

//		someText->mimeSourceFactory()->setExtensionType( "html", "text/html;charset=iso8859-1");
//		someText->mimeSourceFactory()->setExtensionType("htm", "text/html;charset=iso8859-1");
	}
	someText->setMimeSourceFactory( mimefuck );
	QString str;
	if( !QFile( strPath + strLang +"/"+ a_str ).exists() )
		str = "index.html";
	else
		str = a_str;
  someText->setDocument( strPath + strLang +"/"+ str );
}













