/***************************************************************************
                             languagedialog.cpp
                             -------------------                                         
    begin                : Tue Nov 9 1999                                           
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd. 
    author		           : Anton Safonov (Maddy)
    author email         : as@bestlinux.net                                          
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.                      
                            http://bestlinux.net                            

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#include "languagedialog.h"

#include <qframe.h>

LanguageDialog::LanguageDialog( QWidget *parent, QString name )
: QDialog( parent, name, TRUE )
{
#ifndef GBLI_DEVEL
    static Atom noDecoration = ::XInternAtom( qt_xdisplay(),
					       "KWM_WIN_DECORATION", False );
		long l = 0;
    XChangeProperty(qt_xdisplay(), winId(), noDecoration, noDecoration, 32,
		  PropModeReplace, (unsigned char *)&l, 1);
#endif
	setFocusPolicy( QWidget::StrongFocus );

	QHBoxLayout *loHBig = new QHBoxLayout( this );
	QVBoxLayout *lo = new QVBoxLayout;
	loHBig->addSpacing( 5 );
	loHBig->addLayout( lo );
	loHBig->addSpacing( 5 );

	QHBoxLayout *layout = new QHBoxLayout;
	lo->addSpacing( 5 );
	lo->addLayout( layout );
	lo->addSpacing( 5 );
	QLabel *titleLabel = new QLabel( "Choose Language", this );
  titleLabel->setFont( QFont( "helvetica", 24 ) );
  QLabel *titleLogo = new QLabel( this );
  titleLogo->setPixmap( LIconLoader::loadIcon("bestlogo.xpm"));
	layout->addSpacing( 15 );
  layout->addWidget( titleLabel, 42 );
	layout->addStretch( 1 );
  layout->addWidget( titleLogo, 0 );

 	QFrame *fr = new QFrame(this);
 	fr->setFrameStyle(QFrame::HLine | QFrame::Sunken);
 	lo->addWidget(fr);

	lang = new LLanguage( this );
	lo->addWidget( lang );

 	QFrame *fr1 = new QFrame(this);
 	fr1->setFrameStyle(QFrame::HLine | QFrame::Sunken);
 	lo->addWidget(fr1);
	lo->addSpacing( 5 );

	QPushButton *cancel;
	cancel = new QPushButton( tr("Cancel"), this );
	connect( cancel, SIGNAL(clicked()), SLOT(goOut()) );
	cancel->setFocusPolicy( QWidget::StrongFocus );
	
	QPushButton *ok;
	ok = new QPushButton( tr("Next>>"), this );
	connect( ok, SIGNAL(clicked()), SLOT(chooseLanguage()) );
	ok->setFocusPolicy( QWidget::StrongFocus );

	QHBoxLayout *loH = new QHBoxLayout( 5 );
	loH->addStretch( 20 );
	loH->addWidget( ok );
	loH->addWidget( cancel );
	lo->addLayout( loH );
	lo->addSpacing( 5 );

}














