/***************************************************************************
                               lcreateusers.cpp
                             -------------------
    begin                : Thu Nov 11 1999
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd.
    author		           : Anton Safonov (Maddy)
    author email         : as@bestlinux.net
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.
                            http://bestlinux.net

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "lcreateusers.h"
#include "linlinehelp.h"

#include <qlayout.h>
#include <qlineedit.h>
#include <qlabel.h>

#include "linlinehelp.h"


LCreateUsers::LCreateUsers( QWidget * parent, const char * name )
    : QWidget( parent, name )
{
    p1 = new QLineEdit( this );
    p1->setEchoMode( QLineEdit::Password );
    p1->installEventFilter( this );
    p2 = new QLineEdit( this );
    p2->installEventFilter( this );
    p2->setEchoMode( QLineEdit::Password );

    pul = new QLineEdit( this );
    pun = new QLineEdit( this );
    pup1 = new QLineEdit( this );
    pup1->setEchoMode( QLineEdit::Password );
    pup2 = new QLineEdit( this );
    pup2->setEchoMode( QLineEdit::Password );

		QWidget *messHolder = new QWidget( this );
    messHolder->setFixedSize( 200, 50 );
    message = new QLabel( messHolder );
    message->setAlignment( AlignTop + AlignLeft + WordBreak );
    message->setFixedSize( 200, 50 );

/*    LInlineHelp* inlineHelp = new LInlineHelp( this );
    inlineHelp->setDocument( "rootpassword_overview.qml" );*/

    QVBoxLayout * V1 = new QVBoxLayout();
    V1->addWidget( new QLabel( tr( "Password:" ), this ), 1 );
    V1->addSpacing(5);
    V1->addWidget( new QLabel( tr( "Password (again):" ), this ), 1 );

    QVBoxLayout * V2 = new QVBoxLayout();
    V2->addWidget( p1, 1 );
    V2->addSpacing(5);
    V2->addWidget( p2 , 1);

    QVBoxLayout * V3 = new QVBoxLayout();
    V3->addWidget( new QLabel( tr( "Account name" ), this ), 1 );
    V3->addSpacing( 5 );
    V3->addWidget( new QLabel( tr( "User name" ), this ), 1 );
    V3->addSpacing( 5 );
    V3->addWidget( new QLabel( tr( "Password:"), this ), 1 );
    V3->addSpacing( 5 );
    V3->addWidget( new QLabel( tr( "Password (again):"), this ), 1 );

    QVBoxLayout * V4 = new QVBoxLayout();
    V4->addWidget( pul, 1 );
    V4->addSpacing( 5 );
    V4->addWidget( pun, 1 );
    V4->addSpacing( 5 );
    V4->addWidget( pup1, 1 );
    V4->addSpacing( 5 );
    V4->addWidget( pup2, 1 );


    QHBoxLayout * H1 = new QHBoxLayout();
    H1->addLayout( V1 );
    H1->addLayout( V2 );

    QHBoxLayout * H2 = new QHBoxLayout();
    H2->addLayout( V3 );
    H2->addLayout( V4 );

    QLabel * lblRoot = new QLabel(tr("Root"), this);
		QFont font( QFont::defaultFont() );
		font.setFamily( "times" );
		font.setPointSize( 18 );
		font.setWeight( QFont::Bold );
    lblRoot->setFont( font );
    QLabel * lblPrimaryUser = new QLabel(tr("Primary User"), this);
    lblPrimaryUser->setFont( font );

    QVBoxLayout * V5 = new QVBoxLayout();
    V5->addStretch( 3 );
    V5->addWidget(lblRoot);
    V5->addSpacing( 7 );
    V5->addLayout( H1 );
    V5->addStretch( 2 );
    V5->addWidget(lblPrimaryUser);
    V5->addSpacing( 7 );
    V5->addLayout( H2 );
    V5->addStretch( 2 );
    V5->addWidget( messHolder );
    V5->addStretch( 3 );

    QHBoxLayout * ML = new QHBoxLayout( this );
    ML->addStretch();
    ML->addLayout( V5 );
    ML->addStretch();
//    ML->addWidget(inlineHelp);

    p1->setFocus();
    connect( p1, SIGNAL(textChanged(const QString &)), this, SLOT(compare()) );
    connect( p2, SIGNAL(textChanged(const QString &)), this, SLOT(compare()) );
    connect( pul, SIGNAL(textChanged(const QString &)), this, SLOT(compare()));
    connect( pup1, SIGNAL(textChanged(const QString &)), this,SLOT(compare()) );
    connect( pup2, SIGNAL(textChanged(const QString &)),this, SLOT(compare()) );
}


void LCreateUsers::keyPressEvent( QKeyEvent * e )
{
    e->ignore();
    if ( e->key() != Key_Enter && e->key() != Key_Return )
			return;

    e->accept();

    if ( p1->hasFocus() )
			p2->setFocus();
    else if ( p2->hasFocus() && password() == QString::null )
			p1->setFocus();
    else
			e->ignore();
}


void LCreateUsers::compare()
{
    emit nextEnabled( this, checkOK() ) ;
}


void LCreateUsers::show()
{
    compare();
    QWidget::show();
    p1->setFocus();
}


bool LCreateUsers::checkOK()
{
//    LRootPasswordData *data = LRootPasswordData::data();

    QString RP1 = p1->text();
    QString RP2 = p2->text();
    QString UL = pul->text();
    QString UP1 = pup1->text();
    QString UP2 = pup2->text();

    if ( RP1.length() >= 5 && RP1 == RP2 && UL.length() > 0 && UP1.length() >=5
   && UP1 == UP2  && UP1 != RP1)
    { 	message->setText( "\n" );
//	data->set_password(RP1);
//	if( RP1.length()<5 ) return( false );
              return( true );
    }

//    data->set_password(QString::null);

    if ( RP1.length() < 5 )	message->setText( tr( "The root password must be at least 5 characters long" ) );
    else if( RP1 != RP2 ) message->setText( tr( /*"The root password do not match\n"*/"Password Mismatch") );
    else if( UL.isEmpty() ) message->setText( tr( "You should type login\n") );
    else if( !acceptableLogin( UL ) ) /*message->setText( i18n( "Incorrect\n") )*/;
    else if( UP1.length() < 5 ) message->setText( tr( "The primary user password should be at least 5 characters") );
    else if( UP1 != UP2 ) message->setText( tr(/*"The primary user password do not match"*/"Password Mismatch") );
    else if( UP1 == RP1) message->setText( tr("Passwords for root and primary user can't be the same") );
    return false;
}



QString LCreateUsers::password()
{
/*    QString result = p1->text();
    if ( result.length() >= 5 && result == p2->text() ) {
	message->setText( "" );
	return result;
    }

    if ( p1->hasFocus() ) {
	message->setText( "" );
    } else if ( result.length() < 5 ) {
	message->setText( tr( "The root password must be at least 5 characters" ) );
    } else if ( hasBeenBad == FALSE && p2->hasFocus() &&
		p2->text() == result.left( p2->text().length() ) &&
		p2->cursorPosition() == (int)p2->text().length() ) {
	message->setText( "" );
    } else {
	message->setText( tr( "The two passwords you entered are not the same" ) );
	hasBeenBad = TRUE;
    }*/
    return p1->text();
}

QString LCreateUsers::userName(){
  return pun->text();
}

QString LCreateUsers::userLogin(){
  return pul->text();
}

QString LCreateUsers::userPassword(){
  return pup1->text();
}

static const char * reservedLogins[] = { "root", "bin", "daemon", "adm",
					 "lp", "sync", "shutdown", "halt",
					 "mail", "news", "uucp", "operator",
					 "games", "gopher", "ftp", "man",
					 "majordom", "postgres", "nobody", "mysql", 0 };

bool LCreateUsers::acceptableLogin( const QString & s )
{
    int i;
    for( i=0; reservedLogins[i] && s != reservedLogins[i]; i++ );
    if ( reservedLogins[i] ) {
              message->setText( tr( "The login name conflicts with a system account") );
	return false;
    }

    i = 0;
    while( i < (int)s.length() && ( ( s[i] >= '0' && s[i] <= '9' ) ||
				    ( s[i] >= 'A' && s[i] <= 'Z' ) ||
				    ( s[i] >= 'a' && s[i] <= 'z' ) ||
				    ( s[i] == '-' || s[i] == '_' ) ) )
	i++;
    if ( i < (int)s.length() ) {
              message->setText( tr( "Illegal characters in login name\n") );
	return false;
    }

    return true;
}



bool LCreateUsers::eventFilter( QObject * o, QEvent * e )
{
    if ( !e || e->type() != QEvent::FocusIn )
	return FALSE;

    if ( password().length() && ( o == p1 || o == p2 ) ) {
	((QLineEdit *)o)->end( FALSE );
	((QLineEdit *)o)->selectAll();
    } else if ( o == p1 ) {
	p1->setText( "" );
	p2->setText( "" );
	compare();
	hasBeenBad = FALSE;
    } else if ( o == p2 ) {
	p2->setText( "" );
	compare();
    }
    return FALSE;
}

