/***************************************************************************
                               liconloader.cpp
                             -------------------
    begin                : Thu Nov 11 1999
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd.
    author		           : Anton Safonov (Maddy)
    author email         : as@bestlinux.net
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.
                            http://bestlinux.net

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "liconloader.h"
#include <qapplication.h>
#include <qpainter.h>


/*!
  \class LIconLoader
  \brief The LIconLoader is the central class to load icons

  Inside the gbli this class is used to load icons from a certain location.
*/


/*!
  Load an icon if available, returns a null pixmap otherwise.
*/
QPixmap LIconLoader::loadIcon( const QString& icon)
{
    return QPixmap(iconpath + '/' + icon);
}


/*!
  Load a movie if available, returns a null movie otherwise.
*/
QMovie LIconLoader::loadMovie( const QString& movie)
{
    QMovie m(iconpath + '/' + movie);

    m.setBackgroundColor( QApplication::palette().normal().base() );
    return m;
}

/*!
  Set the folder where the icons can be found.
 */
void LIconLoader::setLoadPath(const QString& path)
{
    iconpath = path;
};


QString LIconLoader::iconpath = "./graphics";




