/***************************************************************************
                               llanguage.cpp
                             -------------------
    begin                : Thu Nov 11 1999
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd.
    author		           : Anton Safonov (Maddy)
    author email         : as@bestlinux.net
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.
                            http://bestlinux.net

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdlib.h>
#include <libintl.h>

#include <qlayout.h>
#include <qlabel.h>
#include <qlistbox.h>

#include <qapplication.h>

#include "llanguage.h"
#include "linlinehelp.h"
#include "liconloader.h"
#include "config.h"
#include "configfile.h"

LLanguage::LLanguage( QWidget * parent, const char * name )
    : QWidget( parent, name )
{
	setFocusPolicy( QWidget::StrongFocus );

  QVBoxLayout * l  = new QVBoxLayout( 5 );
  QHBoxLayout *lrh = new QHBoxLayout( 5 );
  QHBoxLayout* h = new QHBoxLayout( this, 0, 6 );

  l->addStretch( 1 );
  l->addLayout( lrh, 8 );
  l->addStretch( 1 );

	h->addSpacing( 17 );
	QLabel *logo = new QLabel( this );
  logo->setPixmap( LIconLoader::loadIcon("startup.gif") );
  h->addWidget( logo );

  lboxLangs = new QListBox( this );
  int numLanguages = sizeof(languages) / sizeof(struct langInfo);
  for( int i = 0; i < numLanguages; i++ )
    lboxLangs->insertItem( languages[i].lang );
  lboxLangs->setCurrentItem( 0 );
	lboxLangs->setFocusPolicy( QWidget::StrongFocus );

/*  int neededHeight = numLanguages * 30;
//lboxLangs->sizeHint().height()+ 15;
  if( neededHeight >= ((QWidget*)this->parent())->height() )
    neededHeight = ((QWidget*)this->parent())->height() - 20;*/
  lboxLangs->setMinimumHeight( 250/*neededHeight*/ );
  lboxLangs->setMinimumWidth( lboxLangs->sizeHint().width() + 15 );
  lboxLangs->setMaximumWidth( lboxLangs->sizeHint().width() + 20 );

  lrh->addStretch( 1 );
  lrh->addWidget( lboxLangs );
  lrh->addStretch( 1 );

  connect( lboxLangs, SIGNAL(highlighted(int)), this, SLOT(setSelected(int)) );

  h->addLayout( l );
	
/*  inlineHelp = new LInlineHelp( this );
  inlineHelp->setDocument( "language_overview.qml" );
  h->addWidget( inlineHelp );*/

  setSelected( 0 );
	lboxLangs->setFocus();
}

LLanguage::~LLanguage() {
}


QString LLanguage::language() const
{
		return lboxLangs->text( lboxLangs->currentItem() ).lower();
}

void LLanguage::showEvent( QShowEvent * )
{
    lboxLangs->setCurrentItem( selected );
  	lboxLangs->setFocus();
}

void LLanguage::hideEvent( QHideEvent * )
{
	  setenv( "LANG", languages[ selected ].key, 1 );
	  setenv( "LINGUAS", languages[ selected ].key, 1 );
	  setenv( "LC_ALL", languages[ selected ].lc_all, 1 );
	  setenv( "LANGUAGE", languages[ selected ].lc_all, 1 );
	  setenv( "LOCALE", languages[ selected ].lc_all, 1 );
		setenv( "SYSFONT", languages[ selected ].font, 1 );
		setenv( "SYSFONTACM", languages[ selected ].map, 1 );
		lboxLangs->setEnabled( false );
}


void LLanguage::setSelected( int arg)
{
    selected = arg;
}

