/***************************************************************************
			                            log.cpp
                             -------------------                                         
    begin                : Sun Oct 31 1999                                           
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd. 
    author		           : Anton Safonov (Maddy)
    author email         : as@bestlinux.net                                          
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.                      
                            http://bestlinux.net                            

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include <qapplication.h>

#include "log.h"
#include "config.h"

FILE *Log::mainlog = NULL;
int Log::iDebugLevel = 2; // less number - less messages

Log::Log( bool a_blUseLocal, char * a_szName )
{
	char *name = NULL;
  if( a_blUseLocal ){
		name = a_szName?a_szName:"debug.log";
  }else{
		name = a_szName?a_szName:"/dev/tty3";
  }
	logfile = fopen( name, "a+" );
	if( !logfile )
		::printf( "Error on log file opening (%s) - no log will be made!\n", name );
}

Log::~Log()
{
  close();
}

void Log::log( int a_iDebugLevel, const char * s, ... )
{
	if( (a_iDebugLevel & 0x1F) > iDebugLevel ) return;
  va_list args;
  va_start( args, s );
  doLog( s, args );
	if( a_iDebugLevel & 0x20 )
		printfLog( s, args );
  va_end( args );
}

void Log::doLog( const char * s, va_list args )
{
  if( !logfile ) return;
	int len = strlen( s );
  fprintf( logfile, "* " );
  vfprintf( logfile, s, args );
	if( s[len-1] != '\n' )
	  fprintf( logfile, "\n" );
  fflush( logfile );
}

void Log::close()
{
  if( logfile ){
		fclose( logfile );
		logfile = NULL;
  }
}

void Log::printfLog( const char * s, va_list args )
{
	int len = strlen( s );
	fprintf( stdout, "* " );
	vfprintf( stdout, s, args );
	if( s[len-1] != '\n' )
		fprintf( stdout, "\n" );
	fflush( stdout );
}


void Log::logMain( int a_iDebugLevel, const char * s, ... )
{
	if( (a_iDebugLevel & 0x1F) > Log::iDebugLevel ) return;
  va_list args;
  va_start( args, s );
  Log::doLogMain( s, args );
	if( a_iDebugLevel & 0x20 )
		Log::printfLogMain( s, args );
  va_end( args );
}

void Log::doLogMain( const char * s, va_list args )
{
  if( !mainlog ){
::printf( "trying to open mainlog!\n" );
		char buf[100];
		sprintf( buf, "%s/tmp", NEWROOT );
    ::mkdir( buf, 01777 );
		sprintf( buf, "%s/tmp/install.log", NEWROOT );
		mainlog = fopen( buf, "a+" );
		CHECK_PTR( mainlog );
		if( !mainlog ) return;
	}
	int len = strlen( s );
  fprintf( mainlog, "* " );
  vfprintf( mainlog, s, args );
	if( s[len-1] != '\n' )
	  fprintf( mainlog, "\n" );

  fflush( mainlog );
}

void Log::printf( int a_iDebugLevel, const char * s, ... )
{
	if( (a_iDebugLevel & 0x1F) > Log::iDebugLevel ) return;
  va_list args;
  va_start( args, s );
	Log::printfLogMain( s, args );
  va_end( args );
}

void Log::closeMain()
{
 	if( mainlog ){
		sync();
		fclose( mainlog );
		mainlog = NULL;
	}
}

void Log::printfLogMain( const char * s, va_list args )
{
	int len = strlen( s );
	fprintf( stdout, "* " );
	vfprintf( stdout, s, args );
	if( s[len-1] != '\n' )
		fprintf( stdout, "\n" );
	fflush( stdout );
}
