/***************************************************************************
                              lvideocard.h
                          -------------------
    begin                : Thu Nov 11 1999
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd.
    author		           : Anton Safonov (Maddy)
    author email         : as@bestlinux.net
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.
                            http://bestlinux.net

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef LVIDEOCARD_H
#define LVIDEOCARD_H

#include "lcarddb.h"
#include "linlinehelp.h"


#include <qwidget.h>
#include <qarray.h>
#include <qradiobutton.h>
#include <qcombobox.h>

class QLineEdit;
class QButtonGroup;
class QLabel;
class QPushButton;
class QGridLayout;
class QGroupBox;


enum XServers { XF86_VGA16=0, XF86_SVGA, XF86_3DLabs, XF86_8514,
		XF86_AGX, XF86_FBDev, XF86_I128, XF86_Mach32, 
		XF86_Mach64, XF86_Mach8, XF86_P9000, XF86_S3,
		XF86_S3V, XF86_W32, LAST_SERVER};


class LVideoCard: public QWidget
{
    Q_OBJECT
public:
    LVideoCard( QWidget * parent, const char * name = 0 );
    ~LVideoCard();

    bool supportsModeClock( float );

    int memory();
    bool memoryProbed();

    QSize maxResolution() { return maxRes; }

    QString clockLine();

    void hide();

    void finish();

    bool defaultVGA16() { return x_server == "XF86_VGA16"; };

signals:
    void nextAvailable( QWidget *, bool );
    
private slots:
    void probeVideoCard();
    void updateClocks();
    void controlNextButton();
    void serverChanged(const QString &server);
    void cardSelected(const QString &card);

private:
    void parseXF86Output( const QString & );
    void updateCardInfo();

    float maxClock;
    QArray<float> clocks;

    int ram;
    QSize maxRes;
    QString cardName;
    QLabel *id, *card_msg;
    QComboBox * videoCard;
    QComboBox *videoRam;
    QLineEdit * maxClockBox;
    QLineEdit * clocksBox;
    QRadioButton * maxClockButton;
    QRadioButton * clocksButton;
    QString x_server;

    QPushButton * probeButton;

    bool hasProbed, serverError;

    LCardDB db;
};


#endif


