/***************************************************************************
                         lvideomodeselector.h
                          -------------------
    begin                : Thu Nov 11 1999
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd.
    author		           : Anton Safonov (Maddy)
    author email         : as@bestlinux.net
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.
                            http://bestlinux.net

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef LVIDEOMODESELECTOR_H
#define LVIDEOMODESELECTOR_H

#include <qwidget.h>
#include <qsize.h>
#include <qcombobox.h>
#include <qcheckbox.h>
#include <qlist.h>

class LMonitor;
class LVideoCard;
class QListView;
class QRadioButton;
class QPushButton;
class LMouse;
class LKeyboard;


class LVideoModeSelector: public QWidget
{
    Q_OBJECT
public:
    LVideoModeSelector( LMonitor * monitor,
			LVideoCard * card,
			LMouse * mouse, LKeyboard * keyboard,
			QWidget * parent, const char * name = 0 );
    void show();

    QString line() const;
    QString name() const;

    int defaultColorDepth();
    QSize virtualResolution();

    int width();
    int height();

private slots:
    void setShowAllModes( bool );
    void updateDepthBoxes();
    void updateBoxes(int);
    void tryMode();

private:
    void add( QSize res, int refresh, float horizSync,
	      float modeClock, const char * modeLine );

    QListView * modes;
    //    QRadioButton * d8, * d16, * d24;
    QComboBox *colDepth, *virtRes;
    QCheckBox *allModes;
    QPushButton * tryModeButton;
    LMonitor * m;
    LVideoCard * vc;
    LMouse * mouseHack;
    LKeyboard * keyboardHack;
    QSize _virtualResolution;
    QList<QSize> vResolutions,resEntries;

    int oldCol, oldVirt;

};


#endif

