/***************************************************************************
  																LWizard
                             -------------------
    begin                : Fri Oct 29 1999
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd.
    author		           : Anton Safonov (Maddy)
    author email         : as@bestlinux.net
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.
                            http://bestlinux.net

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef LWIZARD_H
#define LWIZARD_H


#include "version.h"
#include "config.h"
#include "liconloader.h"
#include "fdisk.h"
#include "diskpartitioner.h"
#include "letcfiles.h"
#include "partitionsel.h"
#include "partitioninfo.h"
#include "lcreateusers.h"
#include "lmonitor.h"
#include "lvideocard.h"
#include "lvideomodeselector.h"
#include "target.h"
#include "lmouse.h"
#include "lnetwork.h"
#include "lkeyboard.h"
#include "ltimezone.h"
#include "disksel.h"
#include "grub.h"
#include "lsound.h"
#include "finalpage.h"

#include <qwizard.h>
#include <qlist.h>
#include <qtranslator.h>
#include <qfont.h>
#include <qprogressbar.h>
#include <qlabel.h>
#include <qapplication.h>
#include <qtextstream.h>
#include <qtimer.h>
#include <qmessagebox.h>
#include <qaccel.h>
#include <qfile.h>
#include <qdir.h>
#include <qmime.h>

// for the kwm hack
#include <X11/X.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>

// symlink(), sync(), reboot()
#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <sys/reboot.h>
#include <stdlib.h>
#include <iostream.h>

#include "installselect.h"
#include "PackageSelect.h"
#include "upgradepage.h"

class QProgressBar;
class QLabel;


class LWizard: public QWizard
{
    Q_OBJECT

public:
    LWizard( const QString& a_lang );
    ~LWizard();

    bool appropriate( QWidget * ) const;

protected slots:
   void help();
   void next();

   virtual void accept();

protected:
    void layOutButtonRow( QHBoxLayout * );
    void layOutTitleRow( QHBoxLayout * layout, const QString & title );

    void keyPressEvent(QKeyEvent *e);

private slots:
    void packageInstallationFinished();
//    void setupPages1();
    void setupPages2();
    void reboot();
    void screendump();
    void version();
    void xterm();

private:
    void init();

    LMouse * mouse;
		UpgradePage *upgradepage;
    LVideoCard * videoCard;
    LMonitor * monitor;
    LVideoModeSelector * videoMode;
    Target* target;
    DiskPartitioner* fdisk;
    DiskSelector* disksel;
    PartitionSelector* partitionselRoot;
    PartitionInfo* partitionInfo;
    LNetwork * network;
    LNetinfo * netdata;
    LKeyboard * keyboard;
    LTimeZone* timezone;
    LCreateUsers* createusers;
    GRUB *grub;
    LSound *sound;
		InstallSelect *installselect;
		PackageSelect *packageselect;
		FinalPage *finalpage;

    QLabel *versionLabel;
    QLabel* progressLabel;
    QProgressBar* progressBar;
    QLabel* titleLogo;

    QLabel * titleLabel;

    bool packagesInstalled;
    QString languagePath;
    QString lang;

    QTranslator* translator;
    void setupTranslator( const QString& lang_ );

		bool upgrade;
};


#endif


