/***************************************************************************
                               lxserver.cpp
                             -------------------
    begin                : Thu Nov 11 1999
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd.
    author		           : Anton Safonov (Maddy)
    author email         : as@bestlinux.net
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.
                            http://bestlinux.net

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "lxserver.h"
#include "qglobal.h"
#include "llanguage.h"

#include <unistd.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <sys/socket.h>
#include <fcntl.h>
#include <netinet/in.h>
#include <signal.h>

#include <stdio.h>
#include <unistd.h>
#include <sys/time.h>
#include <sys/resource.h>

#include <qregexp.h>
#include <qfile.h>
#include <qfileinfo.h>
#include <qtextstream.h>

bool LXServer::runSVGA = false;

LXServer::LXServer()
{
    r = false;

    // make xlib go to to the same server
    setenv( "DISPLAY", "127.0.0.1:1", 1 );

		LXServer::runSVGA = allowsSVGA();
		char *serverName = LXServer::runSVGA? "XF86_SVGA": "XF86_VGA16";
printf( "Running %s server\n", serverName );

    xpid = fork();
    if ( xpid == 0 ) {
			int i = getdtablesize();
			while( i >= 0 ) {
	  	  close( i );
	    	i--;
			}
			open( "/dev/null", O_RDWR );
			dup( 0 );
			if ( open( "/tmp/xserver-output",
		  	O_WRONLY|O_CREAT|O_TRUNC, 0777 ) < 0 )
		    dup( 0 );
			::nice( -19 );
			execl( LXServer::path() + serverName, serverName, ":1", "vt08",
      	"-bestRefresh", "-xf86config", "/tmp/XF86Config_own", "-cc", "3",
	      0 );
			exit( 0 );
    }
printf( "xpid: %d\n", xpid );

		int count = 0;
    while( !r && count++ < 60 ) {
			// make a nice socket for the X server probe
			int datafd = socket( AF_INET, SOCK_STREAM, 0 );
			if ( datafd < 0 )
	  	  return;
			int on = 1;
			if (setsockopt( datafd, SOL_SOCKET, SO_REUSEADDR, &on, sizeof(on))<0)
	  	  return;
			struct sockaddr_in probe;
			probe.sin_family = AF_INET;
			probe.sin_addr.s_addr = htonl( 0x7f000001 );
			probe.sin_port = htons( 6001 );

			// then try to connect until an attempt succeeds
			r = connect( datafd, (struct sockaddr *)&probe, sizeof(probe) ) >= 0;
			if ( !r )
		    sleep( 1 );
    }

		if( !r ) return;

    // succeeded.  keep the connection open, so the X server won't
    // exit.  start a window manager.
    if ( (lwmpid = fork()) == 0 ) {
        int i = getdtablesize();
        while( i >= 0 ) {
            close( i );
            i--;
        }
        open( "/dev/null", O_RDWR );
        dup( 1 );
        dup( 2 );
        ::sleep( 1 );
        ::nice( -18 );
		    execl( "./lwm/lwm", "lwm", "-style", "windows", 0 );
        exit( 0 );
    }
printf( "lwmpid pid: %d\n", lwmpid );
		r = true;
}

bool LXServer::allowsSVGA()
{
  int xpid1 = fork();
  if ( xpid1 == 0 ) {
		int i = getdtablesize();
		while( i >= 0 ) {
  	  close( i );
    	i--;
		}
		open( "/dev/null", O_RDWR );
		dup( 0 );
		nice( -17 );
		if ( open( "/tmp/xserver-output",
	  	O_WRONLY|O_CREAT|O_TRUNC, 0777 ) < 0 )
	    dup( 0 );
		execl( LXServer::path()+"XF86_SVGA", "XF86_SVGA", ":2", "vt08",
    	"-bestRefresh", "-probeonly", "-xf86config", "/tmp/XF86Config_own", "-cc", "3",
      0 );
		exit( 0 );
  }
//printf( "xpid1: %d\n", xpid1 );
	::waitpid( xpid1, NULL, 0 );

	bool serverError = true; // by default it's safer
  QFile f( "/tmp/xserver-output" );
  if ( f.open( IO_ReadOnly ) ) { // file opened successfully
	 	QTextStream t( &f );	    // use a text stream
		QString xf86 = t.read();

		int pos;
    int len;

    serverError = (QRegExp("server error").match( xf86, 0, &len ) >= 0);
if( serverError )
	printf( "Server error!\n" );
    if( !serverError ){
	    serverError = (QRegExp("None of the configured devices were detected").match( xf86, 0, &len ) >= 0);
if( serverError )
	printf( "No device found!\n" );
		}

		if( !serverError ){
			serverError = true;
      QRegExp mode( "(\\*\\*) [^ ]*: Mode " );
			pos = 0;
      while( (pos = mode.match( xf86, pos, &len )) >= 0 ){
      	QString tmp = xf86.mid( pos+len, 9 );
  			if( tmp == "\"640x480\"" ){
  				serverError = false;
					break;
				}
      }
if( serverError )
	printf( "No appropriate mode found!\n" );
		}
  	f.close();
	}
printf( "Xserver%s allow%s SVGA\n", serverError?" doesn't":"", serverError?"":"s" );

	return !serverError;
}

int LXServer::startKWM( int a_iLangCode )
{
		::kill( lwmpid, 9 );
		::waitpid( lwmpid, NULL, 0 );
		lwmpid = 0;

    // succeeded.  keep the connection open, so the X server won't
    // exit.  start a window manager.
    if ( (kwmpid = fork()) == 0 ) {
			int i = getdtablesize();
			while( i >= 0 ) {
	  	  close( i );
	    	i--;
			}
			open( "/dev/null", O_RDWR );
			dup( 1 );
			dup( 2 );
			::nice( -18 );
	    setenv( "LC_ALL", languages[a_iLangCode].lc_all, 1 );
	    setenv( "LANG", languages[a_iLangCode].key, 1 );
			execl( "/usr/bin/kwm", "kwm", "-style", "windows", 0 );
/*			char cmd[128];
			sprintf( cmd, "LC_ALL=%s LANG=%s /usr/bin/kwm -style windows",
				languages[a_iLangCode].lc_all, languages[a_iLangCode].key );
			system( cmd );*/
			exit( 0 );
    }
printf( "kwmpid: %d\n", kwmpid );
		return kwmpid;
}

LXServer::~LXServer()
{
  ::kill( kwmpid, 15 );
  ::waitpid( kwmpid, NULL, 0 );

  ::kill( xpid, 15 );
  ::waitpid( xpid, NULL, 0 );
}





































