/***************************************************************************
                               main.cpp
                             -------------------
    begin                : Thu Nov 11 1999
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd.
    author		           : Anton Safonov (Maddy)
    author email         : as@bestlinux.net
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.
                            http://bestlinux.net

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "config.h"
#include <stdio.h>

#include <qapplication.h>
#include <qwindowsstyle.h>
#include <qdir.h>
#include <qtranslator.h>
#include <qstylesheet.h>
#include <qaccel.h>
#include <qstring.h>
#include <qfile.h>
#include <qmessagebox.h>
#include <qtextstream.h>

#include "liconloader.h"
#include "lxserver.h"
#include "lwizard.h"
#include "llanguage.h"
#include "languagedialog.h"

// symlink, unlink
#include <unistd.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <sys/reboot.h>
#include <stdlib.h>
#include <signal.h>

int main( int argc, char ** argv )
{
  bool remote = FALSE;
  // check if we are running remote
  for( int i=0; i<argc; i++ )
    if( !strcmp(argv[i],"-display") )
      remote = TRUE;

  // helpful while debugging
  PartitionInfo::unMounting();
  
  // create some folders we need in the future
  ::mkdir( "/mnt", 0777 );
  ::mkdir( "/mnt/root", 0777 ); // for new root
  ::mkdir( "/mnt/tmp", 0777 );  // to test for existing partitions

#ifndef GBLI_DEVEL
		system( "/usr/sbin/mouseconfig --kickstart" );
		::unlink( "/tmp/mouselnk" );
		::symlink( "/dev/mouse", "/tmp/mouselnk" );// Lets set the device

		// And now change the protocol in XF86Config
		char mlink[128];
		memset( mlink, 0, sizeof( mlink ) );
		readlink( "/dev/mouse", mlink, 128 );
		if( !strcmp( mlink, "psaux" ) ){
			system( "cp -f /mnt/install/live/gbli/XF86Config_own /tmp/" );
		}else{
			system( "cp -f /mnt/install/live/gbli/XF86Config_own /tmp/XF86Config_ownold" );
			QFile xfconf( "/tmp/XF86Config_ownold" );
			xfconf.open( IO_ReadOnly );
			QFile xfconfnew( "/tmp/XF86Config_own" );
			xfconfnew.open( IO_WriteOnly );
			QTextStream inf( &xfconf );
			QTextStream outf( &xfconfnew );
			while( !inf.eof() ){
				QString str( inf.readLine() );
				if( str.find( "Protocol" ) != -1 &&
					str.find( "PS" ) != -1 )
					outf << "Protocol\t\"Microsoft\"" << endl;
				else
					outf << str << endl;
			}
			xfconf.close();
			xfconfnew.close();
			system( "rm -f /tmp/XF86Config_ownold" );
		}

    LXServer s;
    if ( !s.serverRunning() && !remote ) {
      printf( "Unable to start the X server.  "
	      "Please contact Best Linux Support.\n" );
      exit( 1 );
    }
#endif

    QApplication::setDesktopSettingsAware( FALSE );
    QApplication::setColorSpec( QApplication::NormalColor );
    QApplication::setStyle( new QWindowsStyle );
    QApplication a( argc, argv );

    // set a nice, small font
    QFont f( "helvetica" );
    f.setPointSize( 12 );
//		QFont::setDefaultFont( f );
//    a.setFont( f );
//    a.setFont(QFont("courier",12,QFont::Normal,false,QFont::KOI8R),true);

#ifndef GBLI_DEVEL
    QApplication::desktop()->setBackgroundColor( Qt::black );
    QApplication::flushX();
#endif

    // allow .qml files
    QMimeSourceFactory::defaultFactory()->setExtensionType("qml", "text/utf8");

    // setup stylesheet for t1 and t2
    QStyleSheetItem* style = new QStyleSheetItem( QStyleSheet::defaultSheet(), "t1" );
    style->setFontFamily( "helvetica" );
    style->setFontWeight( QFont::Bold);
    style->setFontSize(14);
    style->setDisplayMode(QStyleSheetItem::DisplayBlock);

    style = new QStyleSheetItem(  QStyleSheet::defaultSheet(), "t2" );
    style->setFontFamily( "helvetica" );
    style->setFontSize(12);
    style->setDisplayMode( QStyleSheetItem::DisplayBlock);

    style = new QStyleSheetItem( QStyleSheet::defaultSheet(), "head" );
    style->setDisplayMode(QStyleSheetItem::DisplayNone);

    // where to find the icons
    LIconLoader::setLoadPath("./graphics");

    // get the language
    QString language = "english";
    for (int i = 1; i < argc-1; i++) {
			if ( QString(argv[i]) == "-language" )
	  	  language = argv[i+1];
    }

#ifdef GBLI_DEVEL
		int width = 640;
		int height = 480;
#else
//  	QWidget *desk = QApplication::desktop();
		int width = 640;//desk->width();
		int height = 480;//desk->height();
#endif

		LanguageDialog *ld = new LanguageDialog();
		ld->setFixedSize( width, height );
    ld->setGeometry( 0, 0, width, height );
    ld->exec();
		int iLangCode = ld->result();
printf( "lang: %d\n", iLangCode );

		switch( iLangCode ){
			case 5: //bad hack, but it's a code of cyrillic in our table
		    f.setCharSet( QFont::KOI8R );
				f.setFamily( "times" );
				f.setPointSize( 14 );
				break;
/*			case 13: // and ukrainian has to be also ? but charset?
		    f.setCharSet( QFont::ISO_8859_5 );
				f.setFamily( "times" );
				f.setPointSize( 14 );
				break;*/
			case -1:
				return 0;
				break;
		}
		QFont::setDefaultFont( f );
		a.setFont( f );

    // finally: create and run the wizard
		language = QString::fromLatin1( languages[iLangCode].lang ).lower();
    LWizard mw( language );
    mw.setCaption( "Graphical Best Linux Installer" );
		mw.setFixedSize( width, height );
    mw.setGeometry( 0, 0, width, height );
	  a.setMainWidget( &mw );
    mw.show();
    mw.setGeometry( 0, 0, width, height );
#ifdef GBLI_DEVEL
		mw.move( 100, 100 );
#endif

#ifndef GBLI_DEVEL
		// lets start normal window manager to make it nice cyrillic
		switch( iLangCode ){
			case 5: //bad hack, but it's a code of cyrillic in our table
//			case 13: // and ukrainian has to be also ? but charset?
				s.startKWM( iLangCode );
				break;
			default:;
		}
#endif

    a.connect (&a, SIGNAL( lastWindowClosed() ), &a, SLOT( quit() ) );
    int res = a.exec();
    ::sync();
		::sleep( 1 );
    ::sync();
		QMessageBox::information( NULL, QObject::tr( "Complete" ),
      QObject::tr( "Congratulations, installation is complete.\n"
      "\n"
      "Remove the boot media and press return to reboot. For information on fixes "
      "which are available for this release of Best Linux, consult the information "
      "available from http://www.bestlinux.net.\n"
      "\n"
      "Information on configuring your system is available in the post install "
      "chapter of the Original Best Linux User's Guide." ),
		  QMessageBox::Ok );
		::sync();
		return res;
}






























































