/***************************************************************************
                           changepartitiondialog.h
                             -------------------                                         
    begin                : Mon Dec 20 1999                                           
    copyright            : (C) 1999 SOT Finnish Software Engineering Ltd. 
    author		           : Anton Safonov (Maddy)
    author email         : as@bestlinux.net                                          
    url		            	 : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.                      
                            http://bestlinux.net                            

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#ifndef CHANGEPARTITIONDIALOG_H
#define CHANGEPARTITIONDIALOG_H

#include "config.h"

#include <qdialog.h>
#include <qcombobox.h>
#include <qcheckbox.h>
#include <qbuttongroup.h>
#include <qlineedit.h>
#include <qlabel.h>

class DiskItem;

class ChangePartitionDialog : public QDialog{
    Q_OBJECT
public:

    ChangePartitionDialog( QWidget* parent, const char *name=0);
    ~ChangePartitionDialog();

    // these variables are used for the communication with the dialog
    QString name;
    int number;
    bool isNewPartition; // then the size is editable
    bool hasSubpartitions;
    int start;
    int size;
    int id;
    bool bootable;
    bool isNew;
    bool willBeFormated;
    // call do settings after you set all of them. Then do the exec()
    void doSettings( DiskItem* disk_);

    QComboBox* freeSpaces;
    QString mountPoint() {
    	if (mountPointEdit->currentText()!="")
    	    return mountPointEdit->currentText();
    	else
    	    return QString::null;
    }
    void setMountPoint( const QString& mp) {
			mountPointEdit->setEditText( mp );
    }

protected slots:
    void done( int );

    void lineEditChanged( const QString&);
    void freeSpaceComboActivated( const QString& );
    void systemComboActivated( const QString& );
    void mountPointComboActivated( const QString& );

private:
    void updateSizeInfo();
    void updateFormatCheck();
    int curStart;
    int curEnd;
    int curSize;
	
    QPushButton* ok;
    QPushButton* cancel;

    QButtonGroup* groupSize;
    QLineEdit* startEdit;
    QLineEdit* endEdit;

    QLabel* sizeInfo;

    QButtonGroup* groupSystem;
    QComboBox* systemCombo;
    QComboBox* mountPointEdit;
    QCheckBox* bootableCheck;
    QCheckBox* formatCheck;

    DiskItem* disk;

    void warnAboutSubpartitions();

};

#endif
