/***************************************************************************
                            partitioninfo.h
                          -------------------
    begin                : Thu Nov 11 1999
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd.
    author		           : Anton Safonov (Maddy)
    author email         : as@bestlinux.net
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.
                            http://bestlinux.net

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef PARTITIONINFO_H
#define PARTITIONINFO_H

#include "config.h"
#include <qwidget.h>
#include <qlabel.h>
#include <qlayout.h>
#include <qlist.h>
#include <qpixmap.h>
#include <qstring.h>
#include <qslider.h>
#include <qframe.h>
#include <qspinbox.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qlistview.h>
#include <qstrlist.h>
#include <qdict.h>

#include <stdio.h>

class PartitionView;

class PartitionInfoItem : public QCheckListItem
{
public:
    enum FormatState { FormatYes, FormatNo, FormatFormatting, FormatDone, FormatNothing };
    PartitionInfoItem( QListView* parent, const QString& descr,
			const QString& mp, const QString& dev,
			const QString& size, FormatState s = FormatNothing);
    ~PartitionInfoItem() {};

    void setFormatState(FormatState s);
    FormatState formatState() { return formatstate; }

    QString device;

    bool isPartition() const { return device[0]=='/'; }
    bool isSwapPartition() const { return isPartition() && text(1) == "swap"; };
    bool isSwapfile() const { return !isPartition();}

    bool isOptional() const { return isoptional; }

    void paintCell( QPainter *,  const QColorGroup & cg,
		    int column, int width, int alignment );

private:
    FormatState formatstate;
    bool isoptional;

};


class PartitionInfo : public QWidget {
    Q_OBJECT
public:

    PartitionInfo(  PartitionView* pview_, QWidget *parent=0, const char *name=0 );
    ~PartitionInfo();
    
    static void unMounting();
		QListView* getView(){ return view; };
		void setDone(){ done = true; };

signals:
    void nextEnabled(QWidget*, bool);
    
public slots:
    void doFormatting();
    void doMounting();
    void writeFstab();


protected:
    void showEvent( QShowEvent * );
    void hideEvent( QHideEvent * );
    void publishMountPoints();
    
private:

		bool done;

    void init();
    PartitionView* pview;
    QListView* view;
    QPushButton* formatButton;

};


#endif

