/***************************************************************************
                            partitionsel.h
                          -------------------
    begin                : Thu Nov 11 1999
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd.
    author		           : Anton Safonov (Maddy)
    author email         : as@bestlinux.net
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.
                            http://bestlinux.net

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef PARTITIONSELECTOR_H
#define PARTITIONSELETOR_H

#include "config.h"
#include <qwidget.h>
#include <qlabel.h>
#include <qlayout.h>
#include <qlist.h>
#include <qpixmap.h>
#include <qstring.h>
#include <qslider.h>
#include <qframe.h>
#include <qspinbox.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qlistview.h>
#include <qstrlist.h>
#include <qdict.h>

class PartitionView;
class PartitionSelector;

class PartitionSelectorItem : public QListViewItem
{
public:
    PartitionSelectorItem( PartitionSelector*, QListView * parent,
			    QString,     QString = QString::null,
			    QString = QString::null);

    QString text( int ) const;

    virtual void paintCell(QPainter * p, const QColorGroup & cg, int column, int width, int align);

private:
    PartitionSelector* selector;
    bool isNone;

};


class PartitionSelector : public QWidget {
    Q_OBJECT
public:
    enum Mode { OnlyRootMode, RootMode, UserMode };

    PartitionSelector( PartitionView* view, Mode m, QWidget *parent=0, const char *name=0 );
    ~PartitionSelector();

    Mode partitionMode() const;

private slots:
		void selectionChanged( QListViewItem * );

protected:
    void showEvent( QShowEvent * );
    void hideEvent( QHideEvent * );

private:
    void init();
    void initRoot();
    void initUser();
    QListView* view;
    PartitionView* pview;
    Mode mode;
    bool initializing;
    QListViewItem* selectedItem;
};


#endif

