/***************************************************************************
                          pciprobe.h  -  description                              
                             -------------------                                         
    begin                : Tue Jan 4 2000                                           
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd. 
    author		 : Anton Safonov (Maddy)                                         
    author email         : as@bestlinux.net                                          
    url			 : http://www.bestlinux.net                          
    email		 : linux@bestlinux.net                              

	       	      Best Linux - Linux from Finland.                      
                            http://bestlinux.net                            

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/




#ifndef PCI_PROBE_H
#define PCI_PROBE_H


/* these are the types of devices we can probe */
enum pciClass {PCI_ETHERNET, PCI_SCSI, PCI_VIDEO, PCI_OTHER, PCI_AUDIO, PCI_UNSET};

/* these define's define what the kernel message is for each class */
#define CLASS_ETHERNET    "Ethernet controller"
#define CLASS_NETWORK     "Network controller"
#define CLASS_SCSI        "SCSI storage controller"
#define CLASS_VIDEO       "VGA compatible"
#define CLASS_VIDEO_OTHER "Display controller"
#define CLASS_AUDIO	  "Multimedia audio controller"
#define CLASS_NONE        "Non-VGA device"
#define CLASS_MASS_STORAGE "mass storage controller"

struct pciDevice {
    enum pciClass      class_;      /* type */
    int                nhits;      /* number of matches in vendor/dev id db */
    char              **name;      /* array of names of PCI cards - malloc! */
    char            **module;      /* array of modules to try - malloc! */
};

void pciFreeDevice( struct pciDevice *p );
int pciProbeDevice(enum pciClass type, struct pciDevice ***devs);

#endif
