/***************************************************************************
                          swapper.cpp  -  description                              
                             -------------------                                         
    begin                : Mon Dec 20 1999                                           
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd. 
    author		           : Anton Safonov (Maddy)
    author email         : as@bestlinux.net                                          
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.                      
                            http://bestlinux.net                            

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#include "swapper.h"

#include <sys/swap.h>

QStringList* Swapper::swap = 0;

/* Swap on the given partition (if not in use yet) */
void Swapper::swapOn( const QString& p )
{
    if ( inUse(p) )
			return;
    if (!swap)
			swap = new QStringList;
    swap->append( p );
#ifndef DO_NOT_SWAP
    ::swapon( p.ascii(), 0 );
#endif
}

/* Returns whether the given swap partition is in use already */
bool Swapper::inUse( const QString& p)
{
    return swap && swap->contains( p );
}

/* swapoff all swap partitions that are in use */
void Swapper::swapOff()
{
    if (!swap || swap->isEmpty() )
			return;

#ifndef DO_NOT_SWAP
    QStringList::Iterator s;
    for (s = swap->begin(); s != swap->end(); ++s) {
			::swapoff( *s );
    }
#endif
    swap->clear();
}
