/***************************************************************************
                              sysconfigfile.cpp
                             -------------------                                         
    begin                : Thu Nov 11 1999                                           
    copyright            : (C) 2000 SOT Finnish Software Engineering Ltd. 
    author		           : Anton Safonov (Maddy)
    author email         : as@bestlinux.net                                          
    url			             : http://www.bestlinux.net
    email		             : linux@bestlinux.net

	       	      Best Linux - Linux from Finland.                      
                            http://bestlinux.net                            

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#include "sysconfigfile.h"

void SysConfigFile::set(const char *var, const char *value, bool withQuotation )
{
    int		len;
    char	**sp;

    len = strlen(var);
    if (!value)
			value = "";
    for (sp = data; sp && *sp; sp++) {
    	if (!strncmp(*sp, var, len) && (*sp)[len] == '=') {
    	    char	*line;

    	    line = (char *) malloc(len + strlen(value) + 4);
    	    if (line == '\0') {
		    		printf( "out of memory in set(%s, %s)\n", var, value );
    				return;
    	    }
					if( withQuotation )
	    	    sprintf(line, "%s=\"%s\"", var, value);
					else
	    	    sprintf(line, "%s=%s", var, value);
    	    free(*sp);
    	    *sp = line;
    	    return;
    	}
    }

    QString line;
    line.sprintf("%s=\"%s\"", var, value);
    append(line);
}

