#include <qapplication.h>
#include <qtranslator.h> 
#include <qobject.h>
#include <qfile.h>
#include <qtextstream.h>
#include <qstring.h>
#include <qregexp.h>


int main(int argc, char *argv[])
{
    QApplication app(argc, argv);
    QTranslator  *translator;
    QString lang, languagePath;

    lang = argv[1];
    languagePath = QString("./")+lang;
 
    printf("# Checking translations for: %s\n", languagePath.ascii());

    // set up the language
    translator = new QTranslator( &app );   
    app.installTranslator( translator );
    translator->load("gbli.qm", languagePath);

    QFile findtr("./findtr.out");
    if (findtr.open(IO_ReadOnly)) { 
      QTextStream is(&findtr);
      QString orig, parsed, tran;

      while (!is.eof()) {
        QString s = is.readLine();
        s = s.stripWhiteSpace();
        
        if (s.left(5) == "msgid") {
          orig = s;
	  orig.remove(0,5);
	  orig = orig.stripWhiteSpace();
        }

        if (s.left(6) == "msgstr") {
	  parsed = orig;
	  parsed.remove(0,1);
	  parsed.remove(parsed.length()-1,1);
	  int pos = parsed.find("::");
	  QString ctx = parsed.left(pos);
	  if (pos>0)
	    parsed.remove(0,pos+2);
	  parsed.replace(QRegExp("\"\""), "");
	parsed.replace(QRegExp("\\\\n"),"\n");

//	    printf("parsed: >%s<\n", parsed.ascii());
//	printf("context: >%s<\n", ctx.ascii());

	  //	  tran = app.translate(ctx, parsed);	  

//	  	  printf("translated: %s\n", tran.ascii());

//	  uint hash = translator->hash(ctx.ascii(), parsed.ascii());
	  if (translator->find(/*hash,*/ ctx.ascii(), parsed.ascii()).isEmpty()) {
	    orig.replace(QRegExp("\"\""), "\"\n\t\"");
	    printf("msgid %s\nmsgstr \"\"\n\n", orig.ascii());
	  }
        }

        if (s.left(1) == "\"")
          orig.append(s);
      }  

      findtr.close();
    }
}
